struct IntIterator : IteratorProtocol {
    var count = 0

    mutating func next() -> Int? {
        guard count < 10 else {
            return nil
        }

        defer {
            count += 1
        }

        return count
    }
}

struct IntSequence : Sequence {
    func makeIterator() -> IntIterator {
        return IntIterator()
    }
}

let sequence = IntSequence()

var array = [Int]()
for element in sequence {
    // elementはInt型
    array.append(element)
}
array // [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]

let stringArray = sequence.map { element in
    return "\(element)"
}
stringArray // ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9"]

let filteredArray = sequence.filter { element in
    return element % 2 == 0
}
filteredArray // [0, 2, 4, 6, 8]